/* A simple animated video game of TAG
   the object of the game is for your "person" to
   tag the other "person" by running into him or her.

   Your person is green ,the computer 's yellow.No
   red boundary may be crossed.

   For the tag to count,the two "people" must be within
   one pixel of being directly on top of one another.*/


#include "dos.h"
#include "stdio.h"
#include "math.h"
#include "time.h"
#include "conio.h"
#include "stdlib.h"

#define YMAX 199
#define XMAX 319

#define COMPUTER 0
#define HUMAN 1

#define IDLE 0
#define DOWN 1
#define UP -1
#define LEFT -1
#define RIGHT 1


void Background();
void line(int startx,int starty,int endx,int endy,int color);
void mempoint(int x,int y,int color);
void palette(int pnum);
void mode(int mode_code);
void display_object(int ob[][5],int lines);
void erase_object(int ob[][5],int lines);
void xhairs(int x,int y) , goto_xy(int x,int y);
void it_comp_move(int ob1[][5],int ob2[][5],int human[][5],int sides);
void not_it_comp_move(int ob1[][5],int ob2[][5],int directx,
		       int directy,int sides);
void show_score(int it,long htime,long ctime);
void update_object(int ob[][5],int x,int y,register int sides);
int readkey(void) , kbhit(void);
int is_legal(int ob[][5],int x,int y,int sides);
int tag(int ob1[][5],int ob2[][5]);
int text();

int human[4][5] ={
		 6,1,6,6,1,
		 2,4,9,3,1,
		 1,9,6,6,1,
		 11,9,6,6,1
		 };/* your sprites */
int human2[4][5] = {
		   6,1,6,6,1,
		   2,4,9,3,1,
		   3,9,6,6,1,
		   9,9,6,6,1
		   };

int computer[4][5]={
		   10,160,5,165,3,
		   10,160,15,165,3,
		   10,170,5,165,3,
		   10,170,15,165,3
		   };/* computer's sprites */
int computer2[4][5]={
		    10,162,5,165,3,
		    10,162,15,165,3,
		    10,168,5,165,3,
		    10,168,15,165,3
		    };

int directx,directy;/*direction of human */

main(void)

{
 union k {/* holds both scan and key codes */
	 char c[2];
	 int i;
	 } key;

 int deltax=0,deltay=0;/* direction of movement */
 int swaph=0,swapc=0;/* select sprites */
 int it=COMPUTER;/* who's it */

 long htime,ctime,starttime,curtime;
 int count;/* used to let the players separate slightly after a tag */
 int epilogh;


 epilogh=text();

 mode(4); /*switch to mode 4 graphics */
 palette(1);/* palette 1 */



 time(&starttime); /* set up the clocks */
 htime=ctime=0;

 display_object(human,4);
 display_object(computer,4);
 count=0;

 /* main game loop */

 do{
   /* update the score counters */
   time(&curtime);
   if(it==COMPUTER) htime += curtime-starttime;
   else ctime+=curtime-starttime;
   time(&starttime);
   show_score(it,htime,ctime);

/*   Background(epilogh);*/
   if (kbhit()) {/* if key pressed */
		directx=directy=IDLE;/*reset direction for each move*/
		key.i=readkey();/*read the key*/
		deltax=0;deltay=0;
		if (!key.c[0]) switch(key.c[1]) {
                                                case 75 : /* left */
						deltax=-1;
						directx=LEFT;
                                                break;
                                                case 77 : /* right */
						deltax=1;
						directx=RIGHT;
                                                break;
                                                case 72 : /* up */
						deltay=-1;
						directy=UP;
                                                break;
                                                case 80 : /* down */
						deltay=1;
						directy=DOWN;
                                                break;
                                                case 71 : /* up left */
						deltax=-1;deltay=-1;
						directy=UP;directx=LEFT;
                                                break;
                                                case 73 : /* up right */
						deltay=-1;deltax=1;
						directy=UP;directx=RIGHT;
                                                break;
                                                case 79 : /*  down left */
						deltay=1;deltax=-1;
						directy=DOWN;directx=LEFT;
                                                break;
                                                case 81 : /* down right */
						deltax=1;deltay=1;
						directy=DOWN;directx=RIGHT;
                                                break;
                                                }   /*  switch  */
		 }



   /* turn off player's person */


   if (swaph<5) display_object(human,4);
   else display_object(human2,4);



   /* see if move is legal */
   if (is_legal(human,deltax,deltay,4)){
		       update_object(human,deltax,deltay,4);
		       update_object(human2,deltax,deltay,4); }

   /* see if a tag has occured */
   if (!count &&tag(human,computer)){
    it=! it; /* switch who is "it" */
    count=6;/* don't allow an instant retag */}

   swaph++;
   if(swaph==10) swaph=0;
   /* redisplay person in new position */


   if(swaph<5) display_object(human2,4);
   else display_object(human2,4);



   /* turn off computer's person */
   if(swaph<5) display_object(computer,4);
   else display_object(computer2,4);

   /* generate the computer's move */
   if(it==COMPUTER) it_comp_move(computer,computer2,human,4);
   else not_it_comp_move(computer,computer2,directx,directy,4);
   if (!count  &&tag(human,computer)) {
    it=!it;/* switch who is "it" */
    count=6; /* don't allow an instant retag */
    /* if computer tag's person , shift computer's X position
       by 2 so that it is not trivial to retag. */

    if(is_legal(computer,2,0,4)) {
		  update_object(computer,2,0,4);
		  update_object(computer2,2,0,4);
		  }/*if*/
     else { update_object(computer,-2,0,4);
	    update_object(computer2,-2,0,4); }
     } /*if*/

   swapc++;
   if (swapc==10) swapc=0;
   /* display computer's person */
   if (swapc<5) display_object(computer,4);
   else display_object(computer2,4);

   Background(epilogh);

   if (count) count--;
   } while (key.c[0]!='q' && htime<999 && ctime<999);
   mode(3);

   if (ctime>htime) printf("Computer wins");
   else printf("You win");

   return 0;

}/* MAIN MENU */


/* ========= Set background ============== */
void Background(int epilogh) {

      line(0,0,319,0,2);       line(0,0,0,170,2);
      line(0,170,319,170,2);   line(319,0,319,170,2);

      line(20,20,299,20,2);    line(20,40,20,150,2);
      line(40,150,299,150,2);  line(299,130,299,40,2);

      line(40,40,150,40,2);    line(175,40,279,40,2);


      line(40,40,40,85,2);     line(40,105,40,130,2);
      line(40,105,60,105,2);   line(80,105,200,105,2);
      line(220,105,299,105,2); line(60,130,150,130,2);
      line(170,130,279,130,2);

      line(60,105,60,60,2);    line(105,60,60,60,2);
      line(125,60,180,60,2);   line(200,60,299,60,2);

      line(80,105,80,85,2);    line(80,85,150,85,2);
      line(170,85,250,85,2);   line(270,85,299,85,2);
      if ( (epilogh==2) || (epilogh==3) ) {
			  line(40,40,40,130,2);  line(40,40,40,170,2);
			  line(299,20,299,60,2); line(20,20,20,40,2);
			  if (epilogh==3) {
				  line(60,60,150,60,2);  line(40,130,130,130,2);
				  line(250,85,270,85,2); line(279,20,279,40,2);
				  line(200,130,299,130,2);
					  }
					  }
} /* Background */

/* Display the score.When YOU or ME is in caps,points are scored. */
/*==========================================*/
void show_score(int it,long htime,long ctime)
     {
     goto_xy(6,24);
     if(it==COMPUTER) printf("HUMAN:%ld",htime);
     else printf("human:%ld",htime);
     gotoxy(26,24);
     if(it==HUMAN) printf("COMPUTER:%ld",ctime);
     else printf ("computer:%ld",ctime);
     }/* show_score*/
/*==== Set the palette =====================*/
void palette(int pnum) {

      union REGS r;

      r.h.bh=1; /*code for palette select */
      r.h.bl=pnum;
      r.h.ah=11; /*set palette function*/
      int86(0x10,&r,&r);
}/* palette */
/*==== Set the video mode ===================*/
void mode (int mode_code) {

      union REGS r;

      r.h.al=mode_code;
      r.h.ah=0;
      int86(0x10,&r,&r);
}/* mode */
/*==========================================*/
/* Draw a line in specified color using Bresnham's integer-based algorithm.*/

void line(int startx,int starty,/*upper-left corner*/
           int endx,int endy,/*lower-right corner*/
            int color) {

	 register int t,distance;
         int x=0,y=0,delta_x,delta_y;
         int incx,incy;

         /* Compute the distances in both directions */
         delta_x=endx-startx;
         delta_y=endy-starty;

         /* Compute the direction of the increment.
            An increment of 0 means either a vertical
            or horizontal line  */

         if (delta_x>0) incx=1;
         else if (delta_x==0) incx=0;
         else incx=-1;
         if (delta_y>0) incy=1;
         else if (delta_y==0) incy=0;
         else incy=-1;

         /* Dtermine which distance is greater */
         delta_x=abs(delta_x);
         delta_y=abs(delta_y);
         if(delta_x>delta_y) distance=delta_x;
         else distance=delta_y;

         /*draw the line*/
         for(t=0;t<=distance+1;t++) {
                                    mempoint(startx,starty,color);
                                    x+=delta_x;
                                    y+=delta_y;
                                    if(x>distance){
                                                  x-=distance;
                                                  startx+=incx;
                                                  }
                                    if(y>distance){
                                                  y-=distance;
                                                  starty+=incy;
                                                  }
                                    }
}/*line*/
/*==Write a point directly to mode 4 graphics RAM====*/
void mempoint(int x,int y,/*coordinate of point */
              int color) /*color*/ {

              union mask {
                         char c[2];
                         int i;
                         } bit_mask;
	      int index,bit_position,p;
              unsigned char t;
              char xor; /* xor color in or overwrite */

              /* pointer to 4 mode graphics RAM */
              char far *ptr=(char far *) 0xB8000000;

              bit_mask.i=0xFFF3F;/* 11111111 00111111 in binary */

              /* check range */
	      if (x<0 || x>XMAX || y<0 || y>YMAX) return;

	      xor=color&128;/*see if xor mode is set*/
	      color=color&127;/*mask off high bit*/

              /*set bit_mask and color bitsto the right location*/
              bit_position=x%4;
              color<<=2*(3-bit_position);
	      bit_mask.i>>=2*bit_position;

              /*find the correct byte in screen memory */
              index=y*40+(x>>2);
	      if (y%2) index+=8152; /* if odd use 2nd bank */

              /* write the color */
	      if (!xor) {/* overwrite mode */
                        t=*(ptr+index) & bit_mask.c[0];
                        *(ptr+index)=t |color;
                        }
              else { /*xor mode */
                   t=*(ptr+index) |(char) 0;
                   *(ptr+index)=t ^ color;
                   }
}/* mempoint */
/*==Read byte directly from the video RAM in mode 4 ===*/
unsigned char read_point(int x,int y) {
            union mask {
                       char c[2];
                       int i;
                       } bit_mask;
            int index,bit_position;
            unsigned char t;

            /*poiinter to mode 4 graphics RAM */
            char far *ptr =(char far *) 0xB8000000;

            bit_mask.i=3; /*11111111 001111111 in binary */
            /*check range for mode 4 */
	    if (x<0 ||x>XMAX || y<0 ||y>YMAX) return 0;

            /* set bit mask and color code bits to the right location */

            bit_position=x%4;
	    bit_mask.i<<=2*(3-bit_position);
            /* find the correct  byte in screen memory */
            index=y*40+(x>>2);
            if(y%2) index+=8152;/*if odd use 2nd bank*/

            /* read  the color */
            t=*(ptr+index)&bit_mask.c[0];
            t>>=2*(3-bit_position);
            return t;
}/* read_point */

/*==Send the cursor to the specified X,Y position ===*/
void goto_xy(int x,int y) {
	    union REGS r;

	    r.h.ah=2; /* cursor addressing function */
	    r.h.dl=x; /* column coordinate */
	    r.h.dh=y; /* row coordinate */
	    r.h.bh=0; /* video game */
	    int86(0x10,&r,&r);
} /* goto_xy */
/*========== Display an object ======================*/
void display_object(int ob[][5],int lines)
{
		   register int i;

		   for(i=0;i<lines;i++) line(ob[i][0],ob[i][1],ob[i][2],ob[i][3],
					      ob[i][4] | 128);
}/* display object */

/*=============== Erase an object=============*/
void erase_object(int ob[][5],int lines)
{
       register int i;
       for(i=0;i<lines;i++) line(ob[i][0],ob[i][1],ob[i][2],ob[i][3],
				    ob[i][4] | 0);


}/* erase object */
/*=====Update an object's position as specifiied in X,Y =====*/
void update_object(int ob[][5],/* object*/int x,int y,/*amount to update*/
		     register int sides )/*number of sides */ {

		  int panos[4][5];
		  int i,j;


		     for(i=0;i<=3;i++)
		      for(j=0;j<=4;j++) { panos[i][j]=ob[i][j]; }

		     for(i=0;i<=3;i++) ob[i][4]=0;
		      erase_object(ob,4);


		     for(i=0;i<=3;i++)
		      for(j=0;j<=4;j++){ ob[i][j]=panos[i][j]; }


		     sides--;
		     for(;sides>=0;sides--){
					   ob[sides][0]+=x;
					   ob[sides][1]+=y;
					   ob[sides][2]+=x;
					   ob[sides][3]+=y;
					   }
}/* update object */
/*=See if a prospective move is legal.Returns 1 if legal;0 othewrwisw===*/
is_legal(int ob[][5],/*object*/int x,int y,/*increment to move*/
	  int sides/*number of sieds the object has */) {
	     if (x==0 && y==0) return 1;
	     sides--;
	     for(;sides>=0;sides--){
				   /*check for out range */
				   if(ob[sides][0]+x>XMAX ||ob[sides][1]+y>YMAX) return 0;
				   if(ob[sides][2]+x<0 || ob[sides][3]+y<0) return 0;
				   /* check for obstacle */
				   if(read_point(ob[sides][0]+x,ob[sides][1]+y)==2) return 0;
				   if(read_point(ob[sides][2]+x,ob[sides][3]+y)==2) return 0;
				   }
	     return 1;
} /* is legal*/
/*=====Generate the computer\s move when it is "it"====*/
void it_comp_move(int ob1[][5],int ob2[][5],int human[][5],int sides){
		register int x,y;
		static skip=0;
		skip++;
		if (skip==3){
			    skip=0;
			    return;
			    }
		 x=0;y=0;

		 /*move toward the human */
		 if(human[0][0]<ob1[0][0]) x=-1;
		 else if(human[0][0]>ob1[0][0]) x=1;

		 if(human[0][1]<ob1[0][1]) y=-1;
		 else if(human[0][1]>ob1[0][1]) y=1;

		 if(is_legal(ob1,x,y,sides)) {
					     update_object(ob1,x,y,sides);
					     update_object(ob2,x,y,sides);
					     }
		 else {/* if not legal,try to go around */
		      if(x && is_legal(ob1,x,0,sides)){
						      update_object(ob1,x,0,sides);
						      update_object(ob2,x,0,sides);
						      }
		      else if(is_legal(ob1,0,y,sides)) {
						       update_object(ob1,0,y,sides);
						       update_object(ob2,0,y,sides);
						       }
		 }
}/* it_comp_move*/
/*=Generate the computer\s move when it is not "it" ====*/
void not_it_comp_move(int ob1[][5],int ob2[][5],int directx,int directy,/*direction of human's last move */
		      int sides)
{

		     register int x,y;
		     static skip=1;

		     skip++;
		     if(skip==3) {
				 skip=0;
				 return;
				 }
		     x=0;y=0;

  /*move in opposite direction as human*/
  x=-directx;
  y=-directy;

  if(is_legal(ob1,x,y,sides)) {
			      update_object(ob1,x,y,sides);
			      update_object(ob2,x,y,sides);
			      }
  else { /*if not legal,try to ro around*/
       if (x && is_legal(ob1,x,0,sides)){
					update_object(ob1,x,0,sides);
					update_object(ob2,x,0,sides);
					}
       else if(is_legal(ob1,0,y,sides)){
				       update_object(ob1,0,y,sides);
				       update_object(ob2,0,y,sides);
				       }
       }
} /* not_it_comp_move */
/*==see if a tag has taken place   =======*/
 tag(int ob1[][5],int ob2[][5]) {
	      register int i;

	      /*to tag ,one figure must be within one pixel
	       of being directly on top of the other */

	      for(i=-1;i<2;i++) {
		 if ( (ob1[0][1]==ob2[2][1]+i || ob1[2][1]==ob2[0][1]+i) &&
		     (ob1[0][0]+i==ob2[0][0]) ) return 1;
		 if  ( (ob1[3][3]==ob2[0][2]+i || ob1[2][0]==ob2[1][2]+i) &&
			( ob1[0][1]+5 )+i==( ob2[0][1]+5 ) ) return 1;
				 }
 return 0;
}/* tag */
/*==Return the 16-bit scan code from the keyboard ====*/
readkey(void)
{
union REGS r;

r.h.ah=0;
return int86(0x16,&r,&r);
} /* readkey */
/*======= text ==============*/
int text() {
   register int i;
   int epilogh;

clrscr();
for(i=0;i<=6;i++) printf(" \n");
printf(" 因  ⤘ ''      駦\n");
printf("  ⥫  婫   櫞   穫  .....\n");
printf("   婫 1 夘   硦   2 ⫨ 嘪 .....\n");
printf("    眫  ⮜ ᢜ 櫞 ⥫  婫 3....\n");
printf("     穫  因  ...    UFO !!!\n");
printf("     驫    : ");
scanf("%d",&epilogh);

return epilogh;

}/* text*/